﻿using System.Threading.Tasks;
using Xamarin.Forms;
#if __IOS__
using Xamarin.Forms.Platform.iOS;
#else
using Xamarin.Forms.Platform.Android;
#endif

namespace Pixiview.Utils
{
    public class FileStore
    {
        public static Task<string> SaveImageToGalleryAsync(ImageSource image)
        {
#if __IOS__
            IImageSourceHandler renderer;
            if (image is UriImageSource)
            {
                renderer = new ImageLoaderSourceHandler();
            }
            else if (image is FileImageSource)
            {
                renderer = new FileImageSourceHandler();
            }
            else
            {
                renderer = new StreamImagesourceHandler();
            }
            var photo = renderer.LoadImageAsync(image).Result;

            var task = new TaskCompletionSource<string>();
            if (photo == null)
            {
                task.SetResult(null);
            }
            else
            {
                photo.SaveToPhotosAlbum((img, error) =>
                {
                    task.SetResult(error?.ToString());
                });
            }
            return task.Task;
#else
            // TODO
#endif
        }
    }
}
